module gf24mul_um_norm(
	input [3:0] i_data0,
	input [3:0] i_data1,
	output [3:0] o_data
);

assign o_data[3] = (i_data0[3] && i_data1[3]) ^ (i_data0[1] && i_data1[3]) ^ (i_data0[0] && i_data1[3]) ^
       		   (i_data0[2] && i_data1[2]) ^ (i_data0[1] && i_data1[2]) ^ (i_data0[3] && i_data1[1]) ^
		   (i_data0[2] && i_data1[1]) ^ (i_data0[1] && i_data1[1]) ^ (i_data0[0] && i_data1[1]) ^
		   (i_data0[3] && i_data1[0]) ^ (i_data0[1] && i_data1[0]);
assign o_data[2] = (i_data0[2] && i_data1[3]) ^ (i_data0[1] && i_data1[3]) ^ (i_data0[3] && i_data1[2]) ^
       		   (i_data0[2] && i_data1[2]) ^ (i_data0[0] && i_data1[2]) ^ (i_data0[3] && i_data1[1]) ^
		   (i_data0[1] && i_data1[1]) ^ (i_data0[2] && i_data1[0]) ^ (i_data0[0] && i_data1[0]);
assign o_data[1] = (i_data0[3] && i_data1[3]) ^ (i_data0[2] && i_data1[3]) ^ (i_data0[1] && i_data1[3]) ^
       		   (i_data0[0] && i_data1[3]) ^ (i_data0[3] && i_data1[2]) ^ (i_data0[1] && i_data1[2]) ^
		   (i_data0[3] && i_data1[1]) ^ (i_data0[2] && i_data1[1]) ^ (i_data0[1] && i_data1[1]) ^
		   (i_data0[3] && i_data1[0]) ^ (i_data0[0] && i_data1[0]);
assign o_data[0] = (i_data0[3] && i_data1[3]) ^ (i_data0[1] && i_data1[3]) ^ (i_data0[2] && i_data1[2]) ^
       		   (i_data0[0] && i_data1[2]) ^ (i_data0[3] && i_data1[1]) ^ (i_data0[0] && i_data1[1]) ^
		   (i_data0[2] && i_data1[0]) ^ (i_data0[1] && i_data1[0]) ^ (i_data0[0] && i_data1[0]);
endmodule


