module gf24sqsc_shared_norm(
	input [3:0] i_share_1,
	input [3:0] i_share_2,
	input [3:0] i_share_3,
	
	output [3:0] o_share_1,
	output [3:0] o_share_2,
	output [3:0] o_share_3
);


assign o_share_1[3] = i_share_1[2] ^ i_share_1[0];
assign o_share_1[2] = i_share_1[3] ^ i_share_1[1];
assign o_share_1[1] = i_share_1[1] ^ i_share_1[0];
assign o_share_1[0] = i_share_1[0];

assign o_share_2[3] = i_share_2[2] ^ i_share_2[0];
assign o_share_2[2] = i_share_2[3] ^ i_share_2[1];
assign o_share_2[1] = i_share_2[1] ^ i_share_2[0];
assign o_share_2[0] = i_share_2[0];

assign o_share_3[3] = i_share_3[2] ^ i_share_3[0];
assign o_share_3[2] = i_share_3[3] ^ i_share_3[1];
assign o_share_3[1] = i_share_3[1] ^ i_share_3[0];
assign o_share_3[0] = i_share_3[0];

endmodule
