module kex_sbox32(
	input [0:3][7:0] i_data,
	output [0:3][7:0] o_data
);

logic [7:0]i_sb1;
logic [7:0]i_sb2;
logic [7:0]i_sb3;
logic [7:0]i_sb4;

logic [7:0]o_sb1;
logic [7:0]o_sb2;
logic [7:0]o_sb3;
logic [7:0]o_sb4;

kex_sbox sb1(
	.i_data(i_sb1),
	.o_data(o_sb1)
);
kex_sbox sb2(
	.i_data(i_sb2),
	.o_data(o_sb2)
);
kex_sbox sb3(
	.i_data(i_sb3),
	.o_data(o_sb3)
);
kex_sbox sb4(
	.i_data(i_sb4),
	.o_data(o_sb4)
);
 
assign i_sb1 = i_data[0];
assign i_sb2 = i_data[1];
assign i_sb3 = i_data[2];
assign i_sb4 = i_data[3];

assign o_data[0] = o_sb1;
assign o_data[1] = o_sb2;
assign o_data[2] = o_sb3;
assign o_data[3] = o_sb4;

endmodule
