module linmap_shared_norm(
	input [7:0] i_share_1,
	input [7:0] i_share_2,
	input [7:0] i_share_3, 
	input [7:0] i_share_4,

	output [7:0] o_share_1,
	output [7:0] o_share_2,
	output [7:0] o_share_3,
	output [7:0] o_share_4
);

assign o_share_1[7] = i_share_1[0] ^ i_share_1[1] ^ i_share_1[2] ^ i_share_1[5] ^ i_share_1[6] ^ i_share_1[7];
assign o_share_1[6] = i_share_1[0] ^ i_share_1[4] ^ i_share_1[5] ^ i_share_1[6];
assign o_share_1[5] = i_share_1[0] ^ i_share_1[1] ^ i_share_1[5] ^ i_share_1[6];
assign o_share_1[4] = i_share_1[0] ^ i_share_1[5] ^ i_share_1[6] ^ i_share_1[7];
assign o_share_1[3] = i_share_1[0] ^ i_share_1[1] ^ i_share_1[3] ^ i_share_1[4] ^ i_share_1[7];
assign o_share_1[2] = i_share_1[0];
assign o_share_1[1] = i_share_1[0] ^ i_share_1[5] ^ i_share_1[6];
assign o_share_1[0] = i_share_1[0] ^ i_share_1[1] ^ i_share_1[2] ^ i_share_1[3] ^ i_share_1[6];

assign o_share_2[7] = i_share_2[0] ^ i_share_2[1] ^ i_share_2[2] ^ i_share_2[5] ^ i_share_2[6] ^ i_share_2[7];
assign o_share_2[6] = i_share_2[0] ^ i_share_2[4] ^ i_share_2[5] ^ i_share_2[6];
assign o_share_2[5] = i_share_2[0] ^ i_share_2[1] ^ i_share_2[5] ^ i_share_2[6];
assign o_share_2[4] = i_share_2[0] ^ i_share_2[5] ^ i_share_2[6] ^ i_share_2[7];
assign o_share_2[3] = i_share_2[0] ^ i_share_2[1] ^ i_share_2[3] ^ i_share_2[4] ^ i_share_2[7];
assign o_share_2[2] = i_share_2[0];
assign o_share_2[1] = i_share_2[0] ^ i_share_2[5] ^ i_share_2[6];
assign o_share_2[0] = i_share_2[0] ^ i_share_2[1] ^ i_share_2[2] ^ i_share_2[3] ^ i_share_2[6];

assign o_share_3[7] = i_share_3[0] ^ i_share_3[1] ^ i_share_3[2] ^ i_share_3[5] ^ i_share_3[6] ^ i_share_3[7];
assign o_share_3[6] = i_share_3[0] ^ i_share_3[4] ^ i_share_3[5] ^ i_share_3[6];
assign o_share_3[5] = i_share_3[0] ^ i_share_3[1] ^ i_share_3[5] ^ i_share_3[6];
assign o_share_3[4] = i_share_3[0] ^ i_share_3[5] ^ i_share_3[6] ^ i_share_3[7];
assign o_share_3[3] = i_share_3[0] ^ i_share_3[1] ^ i_share_3[3] ^ i_share_3[4] ^ i_share_3[7];
assign o_share_3[2] = i_share_3[0];
assign o_share_3[1] = i_share_3[0] ^ i_share_3[5] ^ i_share_3[6];
assign o_share_3[0] = i_share_3[0] ^ i_share_3[1] ^ i_share_3[2] ^ i_share_3[3] ^ i_share_3[6];

assign o_share_4[7] = i_share_4[0] ^ i_share_4[1] ^ i_share_4[2] ^ i_share_4[5] ^ i_share_4[6] ^ i_share_4[7];
assign o_share_4[6] = i_share_4[0] ^ i_share_4[4] ^ i_share_4[5] ^ i_share_4[6];
assign o_share_4[5] = i_share_4[0] ^ i_share_4[1] ^ i_share_4[5] ^ i_share_4[6];
assign o_share_4[4] = i_share_4[0] ^ i_share_4[5] ^ i_share_4[6] ^ i_share_4[7];
assign o_share_4[3] = i_share_4[0] ^ i_share_4[1] ^ i_share_4[3] ^ i_share_4[4] ^ i_share_4[7];
assign o_share_4[2] = i_share_4[0];
assign o_share_4[1] = i_share_4[0] ^ i_share_4[5] ^ i_share_4[6];
assign o_share_4[0] = i_share_4[0] ^ i_share_4[1] ^ i_share_4[2] ^ i_share_4[3] ^ i_share_4[6];


endmodule 

