/* -----------------------------------------------------------------------------------------------
	Clk sync
----------------------------------------------------------------------------------------------- */ 

module clk_sync_ack(
	input i_sreg_clk,
	input i_rst_n,
	input i_key_stable,
	output logic o_key_stable_sync
);

always_ff @(posedge i_sreg_clk or negedge i_rst_n)
if (!i_rst_n)
	o_key_stable_sync <= 1'b0;
else
	o_key_stable_sync <= i_key_stable;

endmodule
