module gf24inv_um_poly(
	input [3:0] i_data,
	output [3:0] o_data
);

assign o_data[3] = (i_data[3] && i_data[2] && i_data[1]) ^ (i_data[3] && i_data[0]) ^ i_data[3] ^ i_data[2];
assign o_data[2] = (i_data[3] && i_data[2] && i_data[1]) ^ (i_data[3] && i_data[2] && i_data[0]) ^ (i_data[2] && i_data[1]) ^ (i_data[3] && i_data[0]) ^ i_data[2];
assign o_data[1] = (i_data[3] && i_data[2] && i_data[1]) ^ (i_data[3] && i_data[1] && i_data[0]) ^ (i_data[2] && i_data[0]) ^ i_data[1] ^ i_data[2] ^ i_data[3];
assign o_data[0] = (i_data[3] && i_data[2] && i_data[1]) ^ (i_data[3] && i_data[2] && i_data[0]) ^ (i_data[3] && i_data[1] && i_data[0]) ^ (i_data[2] && i_data[1] && i_data[0]) ^ (i_data[3] && i_data[1]) ^ (i_data[3] && i_data[0]) ^ (i_data[2] && i_data[1]) ^ i_data[0] ^  i_data[1] ^ i_data[2];

endmodule

// o_x = XYZ + XV + X + Y shared
// o_y = xyz + xyv + yz + xv + y shared
// o_z = XYZ + XZV + YV + Z + Y + X
// o_v = XYZ + XYV + XZV + YZV + XZ + XV + YZ + V + Z + Y 
